/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "rcfile_y.y" /* yacc.c:339  */

/*
 * rcfile_y.y -- Run control file parser for fetchmail
 *
 * For license terms, see the file COPYING in this directory.
 */

#include "config.h"
#include "fetchmail.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#if defined(HAVE_SYS_WAIT_H)
#include <sys/wait.h>
#endif
#include <sys/stat.h>
#include <errno.h>
#if defined(STDC_HEADERS)
#include <stdlib.h>
#endif
#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif
#include <string.h>

#if defined(__CYGWIN__)
#include <sys/cygwin.h>
#endif /* __CYGWIN__ */

#include "fetchmail.h"
#include "i18n.h"
  
/* parser reads these */
char *rcfile;			/* path name of rc file */
struct query cmd_opts;		/* where to put command-line info */

/* parser sets these */
struct query *querylist;	/* head of server list (globally visible) */

static struct query current;	/* current server record */
static int prc_errflag;
static struct hostdata *leadentry;
static flag trailer;

static void record_current(void);
static void user_reset(void);
static void reset_server(const char *name, int skip);

/* these should be of size PATH_MAX */
char currentwd[1024] = "", rcfiledir[1024] = "";

/* using Bison, this arranges that yydebug messages will show actual tokens */
extern char * yytext;
#define YYPRINT(fp, type, val)	fprintf(fp, " = \"%s\"", yytext)

#line 122 "rcfile_y.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_RCFILE_Y_H_INCLUDED
# define YY_YY_RCFILE_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    DEFAULTS = 258,
    POLL = 259,
    SKIP = 260,
    VIA = 261,
    AKA = 262,
    LOCALDOMAINS = 263,
    PROTOCOL = 264,
    AUTHENTICATE = 265,
    TIMEOUT = 266,
    KPOP = 267,
    SDPS = 268,
    ENVELOPE = 269,
    QVIRTUAL = 270,
    USERNAME = 271,
    PASSWORD = 272,
    FOLDER = 273,
    SMTPHOST = 274,
    FETCHDOMAINS = 275,
    MDA = 276,
    BSMTP = 277,
    LMTP = 278,
    PASSWORDFILE = 279,
    PASSWORDFD = 280,
    SMTPADDRESS = 281,
    SMTPNAME = 282,
    SPAMRESPONSE = 283,
    PRECONNECT = 284,
    POSTCONNECT = 285,
    LIMIT = 286,
    WARNINGS = 287,
    INTERFACE = 288,
    MONITOR = 289,
    PLUGIN = 290,
    PLUGOUT = 291,
    IS = 292,
    HERE = 293,
    THERE = 294,
    TO = 295,
    MAP = 296,
    BATCHLIMIT = 297,
    FETCHLIMIT = 298,
    FETCHSIZELIMIT = 299,
    FASTUIDL = 300,
    EXPUNGE = 301,
    PROPERTIES = 302,
    SET = 303,
    LOGFILE = 304,
    DAEMON = 305,
    SYSLOG = 306,
    IDFILE = 307,
    PIDFILE = 308,
    INVISIBLE = 309,
    POSTMASTER = 310,
    BOUNCEMAIL = 311,
    SPAMBOUNCE = 312,
    SOFTBOUNCE = 313,
    SHOWDOTS = 314,
    BADHEADER = 315,
    ACCEPT = 316,
    REJECT_ = 317,
    PROTO = 318,
    AUTHTYPE = 319,
    STRING = 320,
    NUMBER = 321,
    NO = 322,
    KEEP = 323,
    FLUSH = 324,
    LIMITFLUSH = 325,
    FETCHALL = 326,
    REWRITE = 327,
    FORCECR = 328,
    STRIPCR = 329,
    PASS8BITS = 330,
    DROPSTATUS = 331,
    DROPDELIVERED = 332,
    DNS = 333,
    SERVICE = 334,
    PORT = 335,
    UIDL = 336,
    INTERVAL = 337,
    MIMEDECODE = 338,
    IDLE = 339,
    CHECKALIAS = 340,
    SSL = 341,
    SSLKEY = 342,
    SSLCERT = 343,
    SSLPROTO = 344,
    SSLCERTCK = 345,
    SSLCERTFILE = 346,
    SSLCERTPATH = 347,
    SSLCOMMONNAME = 348,
    SSLFINGERPRINT = 349,
    PRINCIPAL = 350,
    ESMTPNAME = 351,
    ESMTPPASSWORD = 352,
    TRACEPOLLS = 353
  };
#endif
/* Tokens.  */
#define DEFAULTS 258
#define POLL 259
#define SKIP 260
#define VIA 261
#define AKA 262
#define LOCALDOMAINS 263
#define PROTOCOL 264
#define AUTHENTICATE 265
#define TIMEOUT 266
#define KPOP 267
#define SDPS 268
#define ENVELOPE 269
#define QVIRTUAL 270
#define USERNAME 271
#define PASSWORD 272
#define FOLDER 273
#define SMTPHOST 274
#define FETCHDOMAINS 275
#define MDA 276
#define BSMTP 277
#define LMTP 278
#define PASSWORDFILE 279
#define PASSWORDFD 280
#define SMTPADDRESS 281
#define SMTPNAME 282
#define SPAMRESPONSE 283
#define PRECONNECT 284
#define POSTCONNECT 285
#define LIMIT 286
#define WARNINGS 287
#define INTERFACE 288
#define MONITOR 289
#define PLUGIN 290
#define PLUGOUT 291
#define IS 292
#define HERE 293
#define THERE 294
#define TO 295
#define MAP 296
#define BATCHLIMIT 297
#define FETCHLIMIT 298
#define FETCHSIZELIMIT 299
#define FASTUIDL 300
#define EXPUNGE 301
#define PROPERTIES 302
#define SET 303
#define LOGFILE 304
#define DAEMON 305
#define SYSLOG 306
#define IDFILE 307
#define PIDFILE 308
#define INVISIBLE 309
#define POSTMASTER 310
#define BOUNCEMAIL 311
#define SPAMBOUNCE 312
#define SOFTBOUNCE 313
#define SHOWDOTS 314
#define BADHEADER 315
#define ACCEPT 316
#define REJECT_ 317
#define PROTO 318
#define AUTHTYPE 319
#define STRING 320
#define NUMBER 321
#define NO 322
#define KEEP 323
#define FLUSH 324
#define LIMITFLUSH 325
#define FETCHALL 326
#define REWRITE 327
#define FORCECR 328
#define STRIPCR 329
#define PASS8BITS 330
#define DROPSTATUS 331
#define DROPDELIVERED 332
#define DNS 333
#define SERVICE 334
#define PORT 335
#define UIDL 336
#define INTERVAL 337
#define MIMEDECODE 338
#define IDLE 339
#define CHECKALIAS 340
#define SSL 341
#define SSLKEY 342
#define SSLCERT 343
#define SSLPROTO 344
#define SSLCERTCK 345
#define SSLCERTFILE 346
#define SSLCERTPATH 347
#define SSLCOMMONNAME 348
#define SSLFINGERPRINT 349
#define PRINCIPAL 350
#define ESMTPNAME 351
#define ESMTPPASSWORD 352
#define TRACEPOLLS 353

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 57 "rcfile_y.y" /* yacc.c:355  */

  int proto;
  int number;
  char *sval;

#line 364 "rcfile_y.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_RCFILE_Y_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 381 "rcfile_y.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  24
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   318

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  99
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  23
/* YYNRULES -- Number of rules.  */
#define YYNRULES  156
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  229

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   353

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    90,    90,    91,    94,    95,    98,    98,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   126,   127,   130,   134,
     135,   136,   139,   140,   143,   144,   147,   148,   151,   152,
     153,   154,   155,   166,   167,   168,   169,   177,   178,   179,
     180,   181,   184,   190,   196,   198,   200,   202,   207,   213,
     214,   222,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   241,   242,   245,   246,   249,   252,   253,   254,   257,
     258,   261,   262,   265,   266,   269,   275,   278,   279,   282,
     283,   286,   287,   290,   296,   304,   305,   306,   307,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   338,   345,   346,   347,
     348,   349,   350,   351,   352,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   367,   368,   370,
     371,   372,   373,   374,   375,   376,   378
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DEFAULTS", "POLL", "SKIP", "VIA", "AKA",
  "LOCALDOMAINS", "PROTOCOL", "AUTHENTICATE", "TIMEOUT", "KPOP", "SDPS",
  "ENVELOPE", "QVIRTUAL", "USERNAME", "PASSWORD", "FOLDER", "SMTPHOST",
  "FETCHDOMAINS", "MDA", "BSMTP", "LMTP", "PASSWORDFILE", "PASSWORDFD",
  "SMTPADDRESS", "SMTPNAME", "SPAMRESPONSE", "PRECONNECT", "POSTCONNECT",
  "LIMIT", "WARNINGS", "INTERFACE", "MONITOR", "PLUGIN", "PLUGOUT", "IS",
  "HERE", "THERE", "TO", "MAP", "BATCHLIMIT", "FETCHLIMIT",
  "FETCHSIZELIMIT", "FASTUIDL", "EXPUNGE", "PROPERTIES", "SET", "LOGFILE",
  "DAEMON", "SYSLOG", "IDFILE", "PIDFILE", "INVISIBLE", "POSTMASTER",
  "BOUNCEMAIL", "SPAMBOUNCE", "SOFTBOUNCE", "SHOWDOTS", "BADHEADER",
  "ACCEPT", "REJECT_", "PROTO", "AUTHTYPE", "STRING", "NUMBER", "NO",
  "KEEP", "FLUSH", "LIMITFLUSH", "FETCHALL", "REWRITE", "FORCECR",
  "STRIPCR", "PASS8BITS", "DROPSTATUS", "DROPDELIVERED", "DNS", "SERVICE",
  "PORT", "UIDL", "INTERVAL", "MIMEDECODE", "IDLE", "CHECKALIAS", "SSL",
  "SSLKEY", "SSLCERT", "SSLPROTO", "SSLCERTCK", "SSLCERTFILE",
  "SSLCERTPATH", "SSLCOMMONNAME", "SSLFINGERPRINT", "PRINCIPAL",
  "ESMTPNAME", "ESMTPPASSWORD", "TRACEPOLLS", "$accept", "rcfile",
  "statement_list", "optmap", "statement", "define_server", "serverspecs",
  "alias_list", "domain_list", "serv_option", "userspecs", "explicits",
  "explicitdef", "userdef", "user0opts", "user1opts", "mapping_list",
  "mapping", "folder_list", "smtp_list", "fetch_list", "num_list",
  "user_option", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353
};
# endif

#define YYPACT_NINF -130

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-130)))

#define YYTABLE_NINF -86

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      55,  -130,   -58,   -32,   251,    46,    55,  -130,  -130,  -130,
    -130,     8,     8,     8,  -130,     8,     8,  -130,     8,  -130,
    -130,  -130,  -130,   122,  -130,  -130,    -5,  -130,   -12,    -8,
      42,    -4,    67,    69,  -130,  -130,  -130,  -130,  -130,  -130,
      73,    86,    87,    39,    47,    54,    51,    88,    89,    94,
      95,    96,    98,    99,   100,  -130,   101,   108,   102,   112,
     116,   118,   119,   134,   135,   138,   143,   144,   145,   147,
     148,   149,   150,   151,   152,   170,   172,    57,   121,  -130,
    -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,
      63,   173,  -130,   175,  -130,  -130,  -130,  -130,   177,   179,
     186,  -130,   187,   188,   189,   190,   191,   192,   193,  -130,
    -130,    90,   106,  -130,  -130,   203,  -130,  -130,  -130,  -130,
    -130,  -130,  -130,  -130,  -130,   194,  -130,   195,  -130,  -130,
    -130,  -130,  -130,  -130,   196,  -130,    74,    56,  -130,  -130,
    -130,   197,  -130,   198,  -130,   199,  -130,  -130,  -130,  -130,
    -130,  -130,  -130,   200,  -130,  -130,  -130,  -130,  -130,  -130,
    -130,  -130,    15,    68,   224,    71,  -130,  -130,  -130,  -130,
    -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,
    -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,
    -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,
    -130,  -130,  -130,  -130,  -130,  -130,  -130,    29,  -130,  -130,
     203,    72,  -130,  -130,  -130,  -130,  -130,   202,  -130,  -130,
    -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130,  -130
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,    31,     0,     0,     0,     0,     3,     4,    32,    29,
      30,     7,     7,     7,    20,     7,     7,    22,     7,    13,
      15,    17,    24,     0,     1,     5,    26,     6,     0,     0,
       0,     0,     0,     0,    21,    23,    14,    16,    18,    25,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   111,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,    64,
       0,     0,    47,     0,   124,   125,    49,   126,     0,     0,
       0,   130,     0,     0,     0,     0,     0,     0,     0,    67,
      33,    27,    72,    73,    79,    71,    81,    19,     8,    11,
       9,    10,    12,    39,    34,    38,    36,    40,    42,    46,
      41,    55,    56,    58,     0,    59,    76,     0,    83,   100,
      87,   103,    89,   104,    91,   105,   109,   110,   101,   102,
     106,   107,    93,   108,   112,   113,   149,   150,    60,    61,
      62,    63,    85,    98,    85,    96,   154,   151,   152,   153,
     155,   156,    69,    70,    66,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,    65,    48,   145,   146,    50,
     147,   148,    68,    51,    52,    53,    54,   127,   128,   129,
     131,   132,   133,   134,    43,    44,    45,     0,    28,    74,
      75,     0,    82,    35,    37,    57,    78,     0,    77,    84,
      88,    90,    92,    94,    99,    97,    95,    80,    86
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -130,  -130,  -130,    32,   131,  -130,  -130,  -130,  -130,   103,
    -130,  -130,   126,  -130,  -130,  -130,    61,  -129,  -130,  -130,
    -130,  -130,  -115
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,     6,    28,     7,     8,    26,   125,   127,   110,
     111,   112,   113,   114,   210,   115,   137,   138,   141,   143,
     145,   153,   116
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     212,    40,    41,    42,    43,    44,    45,     9,   219,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    10,   219,    70,   219,    71,    72,    73,
      74,    75,    76,   174,    29,    30,    24,    31,    32,    27,
      33,   128,   129,   117,   224,    77,   217,   118,     1,     2,
       3,   120,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   218,   227,    40,    41,    42,    43,
      44,    45,   130,     4,    46,    47,   225,   185,   119,   226,
     186,   131,   -85,   216,   189,   217,   133,   134,   172,   173,
     132,   164,    48,    65,    66,    67,    68,   192,   193,   194,
     163,   165,   121,   164,   122,   174,   164,    25,   123,   -85,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      77,   124,   126,   135,   136,   187,   188,   207,   190,   139,
     140,   142,   191,   144,   146,   147,   148,   150,    89,    90,
      91,    92,    93,    34,   149,    96,    35,   151,    36,    37,
      38,    39,   152,   154,   155,   106,   107,   108,   109,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     156,   157,   186,   158,   187,   188,   189,   190,   159,   160,
     161,   191,   162,   164,   208,   166,   167,   168,   169,   192,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,   170,   171,   209,   195,
      69,   196,   197,    70,   198,    71,    72,    73,    74,    75,
      76,   199,   200,   201,   202,   203,   204,   205,   206,   213,
     214,   215,   220,   221,   222,   217,   223,   228,     0,     0,
     211,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,     0,     0,     0,     0,     0,    94,    95,     0,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    11,     0,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,     0,     0,     0,     0,     0,     0,     0,    23
};

static const yytype_int16 yycheck[] =
{
     115,     6,     7,     8,     9,    10,    11,    65,   137,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    65,   163,    40,   165,    42,    43,    44,
      45,    46,    47,    14,    12,    13,     0,    15,    16,    41,
      18,    12,    13,    65,    39,    60,    41,    65,     3,     4,
       5,    65,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    38,   210,     6,     7,     8,     9,
      10,    11,    63,    48,    14,    15,    38,    78,    66,    38,
      81,    64,    38,    39,    85,    41,    65,    66,    61,    62,
      66,    65,    16,    33,    34,    35,    36,    98,    65,    66,
      69,    70,    65,    65,    65,    14,    65,     6,    65,    65,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      60,    65,    65,    65,    65,    83,    84,    67,    86,    65,
      65,    65,    90,    65,    65,    65,    65,    65,    78,    79,
      80,    81,    82,    51,    66,    85,    54,    65,    56,    57,
      58,    59,    66,    65,    65,    95,    96,    97,    98,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      66,    66,    81,    65,    83,    84,    85,    86,    65,    65,
      65,    90,    65,    65,   111,    66,    66,    66,    66,    98,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    66,    65,   112,    66,
      37,    66,    65,    40,    65,    42,    43,    44,    45,    46,
      47,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    65,    41,    66,    65,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    -1,    -1,    83,    84,    -1,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    47,    -1,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,    48,   100,   101,   103,   104,    65,
      65,    47,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    67,     0,   103,   105,    41,   102,   102,
     102,   102,   102,   102,    51,    54,    56,    57,    58,    59,
       6,     7,     8,     9,    10,    11,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      40,    42,    43,    44,    45,    46,    47,    60,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
     108,   109,   110,   111,   112,   114,   121,    65,    65,    66,
      65,    65,    65,    65,    65,   106,    65,   107,    12,    13,
      63,    64,    66,    65,    66,    65,    65,   115,   116,    65,
      65,   117,    65,   118,    65,   119,    65,    65,    65,    66,
      65,    65,    66,   120,    65,    65,    66,    66,    65,    65,
      65,    65,    65,   115,    65,   115,    66,    66,    66,    66,
      66,    65,    61,    62,    14,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    81,    83,    84,    85,
      86,    90,    98,    65,    66,    66,    66,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    67,   108,   111,
     113,    67,   121,    65,    65,    65,    39,    41,    38,   116,
      65,    65,    65,    66,    39,    38,    38,   121,    65
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    99,   100,   100,   101,   101,   102,   102,   103,   103,
     103,   103,   103,   103,   103,   103,   103,   103,   103,   103,
     103,   103,   103,   103,   103,   103,   103,   103,   103,   104,
     104,   104,   105,   105,   106,   106,   107,   107,   108,   108,
     108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   109,   109,   110,   110,   111,   112,   112,   112,   113,
     113,   114,   114,   115,   115,   116,   116,   117,   117,   118,
     118,   119,   119,   120,   120,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     0,     4,     4,
       4,     4,     4,     2,     3,     2,     3,     2,     3,     4,
       2,     3,     2,     3,     2,     3,     2,     3,     4,     2,
       2,     1,     0,     2,     1,     2,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     2,     1,
       2,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       2,     2,     2,     2,     1,     2,     2,     1,     2,     2,
       2,     1,     1,     1,     2,     2,     2,     3,     3,     0,
       2,     1,     2,     1,     2,     1,     3,     1,     2,     1,
       2,     1,     2,     1,     2,     3,     2,     3,     2,     3,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yytype)
    {
          case 65: /* STRING  */
#line 86 "rcfile_y.y" /* yacc.c:1257  */
      { free (((*yyvaluep).sval)); }
#line 1409 "rcfile_y.c" /* yacc.c:1257  */
        break;


      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 8:
#line 101 "rcfile_y.y" /* yacc.c:1646  */
    {run.logfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 1673 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 9:
#line 102 "rcfile_y.y" /* yacc.c:1646  */
    {run.idfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 1679 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 10:
#line 103 "rcfile_y.y" /* yacc.c:1646  */
    {run.pidfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 1685 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 11:
#line 104 "rcfile_y.y" /* yacc.c:1646  */
    {run.poll_interval = (yyvsp[0].number);}
#line 1691 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 12:
#line 105 "rcfile_y.y" /* yacc.c:1646  */
    {run.postmaster = (yyvsp[0].sval);}
#line 1697 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 13:
#line 106 "rcfile_y.y" /* yacc.c:1646  */
    {run.bouncemail = TRUE;}
#line 1703 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 14:
#line 107 "rcfile_y.y" /* yacc.c:1646  */
    {run.bouncemail = FALSE;}
#line 1709 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 15:
#line 108 "rcfile_y.y" /* yacc.c:1646  */
    {run.spambounce = TRUE;}
#line 1715 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 16:
#line 109 "rcfile_y.y" /* yacc.c:1646  */
    {run.spambounce = FALSE;}
#line 1721 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 17:
#line 110 "rcfile_y.y" /* yacc.c:1646  */
    {run.softbounce = TRUE;}
#line 1727 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 18:
#line 111 "rcfile_y.y" /* yacc.c:1646  */
    {run.softbounce = FALSE;}
#line 1733 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 19:
#line 112 "rcfile_y.y" /* yacc.c:1646  */
    {run.properties = (yyvsp[0].sval);}
#line 1739 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 20:
#line 113 "rcfile_y.y" /* yacc.c:1646  */
    {run.use_syslog = TRUE;}
#line 1745 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 21:
#line 114 "rcfile_y.y" /* yacc.c:1646  */
    {run.use_syslog = FALSE;}
#line 1751 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 22:
#line 115 "rcfile_y.y" /* yacc.c:1646  */
    {run.invisible = TRUE;}
#line 1757 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 23:
#line 116 "rcfile_y.y" /* yacc.c:1646  */
    {run.invisible = FALSE;}
#line 1763 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 24:
#line 117 "rcfile_y.y" /* yacc.c:1646  */
    {run.showdots = FLAG_TRUE;}
#line 1769 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 25:
#line 118 "rcfile_y.y" /* yacc.c:1646  */
    {run.showdots = FLAG_FALSE;}
#line 1775 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 26:
#line 126 "rcfile_y.y" /* yacc.c:1646  */
    {record_current();}
#line 1781 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 28:
#line 131 "rcfile_y.y" /* yacc.c:1646  */
    {yyerror(GT_("server option after user options"));}
#line 1787 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 29:
#line 134 "rcfile_y.y" /* yacc.c:1646  */
    {reset_server((yyvsp[0].sval), FALSE); free((yyvsp[0].sval));}
#line 1793 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 30:
#line 135 "rcfile_y.y" /* yacc.c:1646  */
    {reset_server((yyvsp[0].sval), TRUE);  free((yyvsp[0].sval));}
#line 1799 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 31:
#line 136 "rcfile_y.y" /* yacc.c:1646  */
    {reset_server("defaults", FALSE);}
#line 1805 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 34:
#line 143 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.server.akalist,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1811 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 35:
#line 144 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.server.akalist,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1817 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 36:
#line 147 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.server.localdomains,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1823 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 37:
#line 148 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.server.localdomains,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1829 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 39:
#line 152 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.via = (yyvsp[0].sval);}
#line 1835 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 41:
#line 154 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.protocol = (yyvsp[0].proto);}
#line 1841 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 42:
#line 155 "rcfile_y.y" /* yacc.c:1646  */
    {
					    current.server.protocol = P_POP3;

					    if (current.server.authenticate == A_PASSWORD)
#ifdef KERBEROS_V5
						current.server.authenticate = A_KERBEROS_V5;
#else
						current.server.authenticate = A_KERBEROS_V4;
#endif /* KERBEROS_V5 */
					    current.server.service = KPOP_PORT;
					}
#line 1857 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 43:
#line 166 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.principal = (yyvsp[0].sval);}
#line 1863 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 44:
#line 167 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.esmtp_name = (yyvsp[0].sval);}
#line 1869 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 45:
#line 168 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.esmtp_password = (yyvsp[0].sval);}
#line 1875 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 46:
#line 169 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef SDPS_ENABLE
					    current.server.protocol = P_POP3;
					    current.server.sdps = TRUE;
#else
					    yyerror(GT_("SDPS not enabled."));
#endif /* SDPS_ENABLE */
					}
#line 1888 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 47:
#line 177 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.uidl = FLAG_TRUE;}
#line 1894 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 48:
#line 178 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.uidl  = FLAG_FALSE;}
#line 1900 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 49:
#line 179 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.checkalias = FLAG_TRUE;}
#line 1906 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 50:
#line 180 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.checkalias  = FLAG_FALSE;}
#line 1912 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 51:
#line 181 "rcfile_y.y" /* yacc.c:1646  */
    {
					current.server.service = (yyvsp[0].sval);
					}
#line 1920 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 52:
#line 184 "rcfile_y.y" /* yacc.c:1646  */
    {
					int port = (yyvsp[0].number);
					char buf[10];
					snprintf(buf, sizeof buf, "%d", port);
					current.server.service = xstrdup(buf);
		}
#line 1931 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 53:
#line 190 "rcfile_y.y" /* yacc.c:1646  */
    {
					int port = (yyvsp[0].number);
					char buf[10];
					snprintf(buf, sizeof buf, "%d", port);
					current.server.service = xstrdup(buf);
		}
#line 1942 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 54:
#line 197 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.interval = (yyvsp[0].number);}
#line 1948 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 55:
#line 199 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.authenticate = (yyvsp[0].proto);}
#line 1954 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 56:
#line 201 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.timeout = (yyvsp[0].number);}
#line 1960 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 57:
#line 203 "rcfile_y.y" /* yacc.c:1646  */
    {
					    current.server.envelope = (yyvsp[0].sval);
					    current.server.envskip = (yyvsp[-1].number);
					}
#line 1969 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 58:
#line 208 "rcfile_y.y" /* yacc.c:1646  */
    {
					    current.server.envelope = (yyvsp[0].sval);
					    current.server.envskip = 0;
					}
#line 1978 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 59:
#line 213 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.qvirtual = (yyvsp[0].sval);}
#line 1984 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 60:
#line 214 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef CAN_MONITOR
					interface_parse((yyvsp[0].sval), &current.server);
#else
					fprintf(stderr, GT_("fetchmail: interface option is only supported under Linux (without IPv6) and FreeBSD\n"));
#endif
					free((yyvsp[0].sval));
					}
#line 1997 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 61:
#line 222 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef CAN_MONITOR
					current.server.monitor = (yyvsp[0].sval);
#else
					fprintf(stderr, GT_("fetchmail: monitor option is only supported under Linux (without IPv6) and FreeBSD\n"));
					free((yyvsp[0].sval));
#endif
					}
#line 2010 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 62:
#line 230 "rcfile_y.y" /* yacc.c:1646  */
    { current.server.plugin = (yyvsp[0].sval); }
#line 2016 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 63:
#line 231 "rcfile_y.y" /* yacc.c:1646  */
    { current.server.plugout = (yyvsp[0].sval); }
#line 2022 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 64:
#line 232 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.dns = FLAG_TRUE;}
#line 2028 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 65:
#line 233 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.dns = FLAG_FALSE;}
#line 2034 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 66:
#line 234 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.envelope = STRING_DISABLED;}
#line 2040 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 67:
#line 235 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.tracepolls = FLAG_TRUE;}
#line 2046 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 68:
#line 236 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.tracepolls = FLAG_FALSE;}
#line 2052 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 69:
#line 237 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.badheader = BHACCEPT;}
#line 2058 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 70:
#line 238 "rcfile_y.y" /* yacc.c:1646  */
    {current.server.badheader = BHREJECT;}
#line 2064 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 71:
#line 241 "rcfile_y.y" /* yacc.c:1646  */
    {record_current(); user_reset();}
#line 2070 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 73:
#line 245 "rcfile_y.y" /* yacc.c:1646  */
    {record_current(); user_reset();}
#line 2076 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 74:
#line 246 "rcfile_y.y" /* yacc.c:1646  */
    {record_current(); user_reset();}
#line 2082 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 76:
#line 252 "rcfile_y.y" /* yacc.c:1646  */
    {current.remotename = (yyvsp[0].sval);}
#line 2088 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 78:
#line 254 "rcfile_y.y" /* yacc.c:1646  */
    {current.remotename = (yyvsp[-1].sval);}
#line 2094 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 85:
#line 269 "rcfile_y.y" /* yacc.c:1646  */
    {if (0 == strcmp((yyvsp[0].sval), "*")) {
					      current.wildcard = TRUE;
					  } else {
					    save_str_pair(&current.localnames, (yyvsp[0].sval), NULL);
					  }
					 free((yyvsp[0].sval));}
#line 2105 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 86:
#line 275 "rcfile_y.y" /* yacc.c:1646  */
    {save_str_pair(&current.localnames, (yyvsp[-2].sval), (yyvsp[0].sval)); free((yyvsp[-2].sval)); free((yyvsp[0].sval));}
#line 2111 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 87:
#line 278 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.mailboxes,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 2117 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 88:
#line 279 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.mailboxes,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 2123 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 89:
#line 282 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.smtphunt, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2129 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 90:
#line 283 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.smtphunt, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2135 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 91:
#line 286 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.domainlist, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2141 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 92:
#line 287 "rcfile_y.y" /* yacc.c:1646  */
    {save_str(&current.domainlist, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2147 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 93:
#line 291 "rcfile_y.y" /* yacc.c:1646  */
    {
			    struct idlist *id;
			    id = save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = (yyvsp[0].number);
			}
#line 2157 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 94:
#line 297 "rcfile_y.y" /* yacc.c:1646  */
    {
			    struct idlist *id;
			    id = save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = (yyvsp[0].number);
			}
#line 2167 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 99:
#line 309 "rcfile_y.y" /* yacc.c:1646  */
    {current.remotename  = (yyvsp[-1].sval);}
#line 2173 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 100:
#line 310 "rcfile_y.y" /* yacc.c:1646  */
    {current.password    = (yyvsp[0].sval);}
#line 2179 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 101:
#line 311 "rcfile_y.y" /* yacc.c:1646  */
    {current.passwordfile = (yyvsp[0].sval);}
#line 2185 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 102:
#line 312 "rcfile_y.y" /* yacc.c:1646  */
    {current.passwordfd  = NUM_VALUE_IN((yyvsp[0].number));}
#line 2191 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 106:
#line 316 "rcfile_y.y" /* yacc.c:1646  */
    {current.smtpaddress = (yyvsp[0].sval);}
#line 2197 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 107:
#line 317 "rcfile_y.y" /* yacc.c:1646  */
    {current.smtpname =    (yyvsp[0].sval);}
#line 2203 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 109:
#line 319 "rcfile_y.y" /* yacc.c:1646  */
    {current.mda         = (yyvsp[0].sval);}
#line 2209 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 110:
#line 320 "rcfile_y.y" /* yacc.c:1646  */
    {current.bsmtp       = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2215 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 111:
#line 321 "rcfile_y.y" /* yacc.c:1646  */
    {current.listener    = LMTP_MODE;}
#line 2221 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 112:
#line 322 "rcfile_y.y" /* yacc.c:1646  */
    {current.preconnect  = (yyvsp[0].sval);}
#line 2227 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 113:
#line 323 "rcfile_y.y" /* yacc.c:1646  */
    {current.postconnect = (yyvsp[0].sval);}
#line 2233 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 114:
#line 325 "rcfile_y.y" /* yacc.c:1646  */
    {current.keep        = FLAG_TRUE;}
#line 2239 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 115:
#line 326 "rcfile_y.y" /* yacc.c:1646  */
    {current.flush       = FLAG_TRUE;}
#line 2245 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 116:
#line 327 "rcfile_y.y" /* yacc.c:1646  */
    {current.limitflush  = FLAG_TRUE;}
#line 2251 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 117:
#line 328 "rcfile_y.y" /* yacc.c:1646  */
    {current.fetchall    = FLAG_TRUE;}
#line 2257 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 118:
#line 329 "rcfile_y.y" /* yacc.c:1646  */
    {current.rewrite     = FLAG_TRUE;}
#line 2263 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 119:
#line 330 "rcfile_y.y" /* yacc.c:1646  */
    {current.forcecr     = FLAG_TRUE;}
#line 2269 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 120:
#line 331 "rcfile_y.y" /* yacc.c:1646  */
    {current.stripcr     = FLAG_TRUE;}
#line 2275 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 121:
#line 332 "rcfile_y.y" /* yacc.c:1646  */
    {current.pass8bits   = FLAG_TRUE;}
#line 2281 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 122:
#line 333 "rcfile_y.y" /* yacc.c:1646  */
    {current.dropstatus  = FLAG_TRUE;}
#line 2287 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 123:
#line 334 "rcfile_y.y" /* yacc.c:1646  */
    {current.dropdelivered = FLAG_TRUE;}
#line 2293 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 124:
#line 335 "rcfile_y.y" /* yacc.c:1646  */
    {current.mimedecode  = FLAG_TRUE;}
#line 2299 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 125:
#line 336 "rcfile_y.y" /* yacc.c:1646  */
    {current.idle        = FLAG_TRUE;}
#line 2305 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 126:
#line 338 "rcfile_y.y" /* yacc.c:1646  */
    {
#ifdef SSL_ENABLE
		    current.use_ssl = FLAG_TRUE;
#else
		    yyerror(GT_("SSL is not enabled"));
#endif 
		}
#line 2317 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 127:
#line 345 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslkey = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2323 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 128:
#line 346 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcert = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2329 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 129:
#line 347 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslproto = (yyvsp[0].sval);}
#line 2335 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 130:
#line 348 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcertck = FLAG_TRUE;}
#line 2341 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 131:
#line 349 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcertfile = prependdir((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2347 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 132:
#line 350 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcertpath = prependdir((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2353 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 133:
#line 351 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcommonname = (yyvsp[0].sval);}
#line 2359 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 134:
#line 352 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslfingerprint = (yyvsp[0].sval);}
#line 2365 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 135:
#line 354 "rcfile_y.y" /* yacc.c:1646  */
    {current.keep        = FLAG_FALSE;}
#line 2371 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 136:
#line 355 "rcfile_y.y" /* yacc.c:1646  */
    {current.flush       = FLAG_FALSE;}
#line 2377 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 137:
#line 356 "rcfile_y.y" /* yacc.c:1646  */
    {current.limitflush  = FLAG_FALSE;}
#line 2383 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 138:
#line 357 "rcfile_y.y" /* yacc.c:1646  */
    {current.fetchall    = FLAG_FALSE;}
#line 2389 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 139:
#line 358 "rcfile_y.y" /* yacc.c:1646  */
    {current.rewrite     = FLAG_FALSE;}
#line 2395 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 140:
#line 359 "rcfile_y.y" /* yacc.c:1646  */
    {current.forcecr     = FLAG_FALSE;}
#line 2401 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 141:
#line 360 "rcfile_y.y" /* yacc.c:1646  */
    {current.stripcr     = FLAG_FALSE;}
#line 2407 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 142:
#line 361 "rcfile_y.y" /* yacc.c:1646  */
    {current.pass8bits   = FLAG_FALSE;}
#line 2413 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 143:
#line 362 "rcfile_y.y" /* yacc.c:1646  */
    {current.dropstatus  = FLAG_FALSE;}
#line 2419 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 144:
#line 363 "rcfile_y.y" /* yacc.c:1646  */
    {current.dropdelivered = FLAG_FALSE;}
#line 2425 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 145:
#line 364 "rcfile_y.y" /* yacc.c:1646  */
    {current.mimedecode  = FLAG_FALSE;}
#line 2431 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 146:
#line 365 "rcfile_y.y" /* yacc.c:1646  */
    {current.idle        = FLAG_FALSE;}
#line 2437 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 147:
#line 367 "rcfile_y.y" /* yacc.c:1646  */
    {current.use_ssl     = FLAG_FALSE;}
#line 2443 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 148:
#line 368 "rcfile_y.y" /* yacc.c:1646  */
    {current.sslcertck   = FLAG_FALSE;}
#line 2449 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 149:
#line 370 "rcfile_y.y" /* yacc.c:1646  */
    {current.limit       = NUM_VALUE_IN((yyvsp[0].number));}
#line 2455 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 150:
#line 371 "rcfile_y.y" /* yacc.c:1646  */
    {current.warnings    = NUM_VALUE_IN((yyvsp[0].number));}
#line 2461 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 151:
#line 372 "rcfile_y.y" /* yacc.c:1646  */
    {current.fetchlimit  = NUM_VALUE_IN((yyvsp[0].number));}
#line 2467 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 152:
#line 373 "rcfile_y.y" /* yacc.c:1646  */
    {current.fetchsizelimit = NUM_VALUE_IN((yyvsp[0].number));}
#line 2473 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 153:
#line 374 "rcfile_y.y" /* yacc.c:1646  */
    {current.fastuidl    = NUM_VALUE_IN((yyvsp[0].number));}
#line 2479 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 154:
#line 375 "rcfile_y.y" /* yacc.c:1646  */
    {current.batchlimit  = NUM_VALUE_IN((yyvsp[0].number));}
#line 2485 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 155:
#line 376 "rcfile_y.y" /* yacc.c:1646  */
    {current.expunge     = NUM_VALUE_IN((yyvsp[0].number));}
#line 2491 "rcfile_y.c" /* yacc.c:1646  */
    break;

  case 156:
#line 378 "rcfile_y.y" /* yacc.c:1646  */
    {current.properties  = (yyvsp[0].sval);}
#line 2497 "rcfile_y.c" /* yacc.c:1646  */
    break;


#line 2501 "rcfile_y.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 380 "rcfile_y.y" /* yacc.c:1906  */


/* lexer interface */
extern char *rcfile;
extern int prc_lineno;
extern char *yytext;
extern FILE *yyin;

static struct query *hosttail;	/* where to add new elements */

void yyerror (const char *s)
/* report a syntax error */
{
    report_at_line(stderr, 0, rcfile, prc_lineno, GT_("%s at %s"), s, 
		   (yytext && yytext[0]) ? yytext : GT_("end of input"));
    prc_errflag++;
}

/** check that a configuration file is secure, returns PS_* status codes */
int prc_filecheck(const char *pathname,
		  const flag securecheck /** shortcuts permission, filetype and uid tests if false */)
{
#ifndef __EMX__
    struct stat statbuf;

    errno = 0;

    /* special case useful for debugging purposes */
    if (strcmp("/dev/null", pathname) == 0)
	return(PS_SUCCESS);

    /* pass through the special name for stdin */
    if (strcmp("-", pathname) == 0)
	return(PS_SUCCESS);

    /* the run control file must have the same uid as the REAL uid of this 
       process, it must have permissions no greater than 600, and it must not 
       be a symbolic link.  We check these conditions here. */

    if (stat(pathname, &statbuf) < 0) {
	if (errno == ENOENT) 
	    return(PS_SUCCESS);
	else {
	    report(stderr, "lstat: %s: %s\n", pathname, strerror(errno));
	    return(PS_IOERR);
	}
    }

    if (!securecheck)	return PS_SUCCESS;

    if (!S_ISREG(statbuf.st_mode))
    {
	fprintf(stderr, GT_("File %s must be a regular file.\n"), pathname);
	return(PS_IOERR);
    }

#ifndef __BEOS__
#ifdef __CYGWIN__
    if (cygwin_internal(CW_CHECK_NTSEC, pathname))
#endif /* __CYGWIN__ */
    if (statbuf.st_mode & (S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH | S_IXOTH))
    {
	fprintf(stderr, GT_("File %s must have no more than -rwx------ (0700) permissions.\n"), 
		pathname);
	return(PS_IOERR);
    }
#endif /* __BEOS__ */

#ifdef HAVE_GETEUID
    if (statbuf.st_uid != geteuid())
#else
    if (statbuf.st_uid != getuid())
#endif /* HAVE_GETEUID */
    {
	fprintf(stderr, GT_("File %s must be owned by you.\n"), pathname);
	return(PS_IOERR);
    }
#endif
    return(PS_SUCCESS);
}

int prc_parse_file (const char *pathname, const flag securecheck)
/* digest the configuration into a linked list of host records */
{
    prc_errflag = 0;
    querylist = hosttail = (struct query *)NULL;

    (void)yytoknum; /* work around compiler warning */

    errno = 0;

    /* Check that the file is secure */
    if ( (prc_errflag = prc_filecheck(pathname, securecheck)) != 0 )
	return(prc_errflag);

    /*
     * Croak if the configuration directory does not exist.
     * This probably means an NFS mount failed and we can't
     * see a configuration file that ought to be there.
     * Question: is this a portable check? It's not clear
     * that all implementations of lstat() will return ENOTDIR
     * rather than plain ENOENT in this case...
     */
    if (errno == ENOTDIR)
	return(PS_IOERR);
    else if (errno == ENOENT)
	return(PS_SUCCESS);

    /* Open the configuration file and feed it to the lexer. */
    if (strcmp(pathname, "-") == 0)
	yyin = stdin;
    else if ((yyin = fopen(pathname,"r")) == (FILE *)NULL) {
	report(stderr, "open: %s: %s\n", pathname, strerror(errno));
	return(PS_IOERR);
    }

    yyparse();		/* parse entire file */

    if (yyin != stdin)
       fclose(yyin);	/* not checking this should be safe, file mode was r */

    if (prc_errflag) 
	return(PS_SYNTAX);
    else
	return(PS_SUCCESS);
}

static void reset_server(const char *name, int skip)
/* clear the entire global record and initialize it with a new name */
{
    trailer = FALSE;
    memset(&current,'\0',sizeof(current));
    current.smtp_socket = -1;
    current.passwordfd = -1;
    current.server.pollname = xstrdup(name);
    current.server.skip = skip;
    current.server.principal = (char *)NULL;
}


static void user_reset(void)
/* clear the global current record (user parameters) used by the parser */
{
    struct hostdata save;

    /*
     * Purpose of this code is to initialize the new server block, but
     * preserve whatever server name was previously set.  Also
     * preserve server options unless the command-line explicitly
     * overrides them.
     */
    save = current.server;

    memset(&current, '\0', sizeof(current));
    current.smtp_socket = -1;
    current.passwordfd = -1;

    current.server = save;
}

/** append a host record to the host list */
struct query *hostalloc(struct query *init /** pointer to block containing
					       initial values */)
{
    struct query *node;

    /* allocate new node */
    node = (struct query *) xmalloc(sizeof(struct query));

    /* initialize it */
    if (init)
	memcpy(node, init, sizeof(struct query));
    else
    {
	memset(node, '\0', sizeof(struct query));
	node->smtp_socket = -1;
	node->passwordfd = -1;
    }

    /* append to end of list */
    if (hosttail != (struct query *) 0)
	hosttail->next = node;	/* list contains at least one element */
    else
	querylist = node;	/* list is empty */
    hosttail = node;

    if (trailer)
	node->server.lead_server = leadentry;
    else
    {
	node->server.lead_server = NULL;
	leadentry = &node->server;
    }

    return(node);
}

static void record_current(void)
/* register current parameters and append to the host list */
{
    (void) hostalloc(&current);
    trailer = TRUE;
}

char *prependdir (const char *file, const char *dir)
/* if a filename is relative to dir, convert it to an absolute path */
{
    char *newfile;
    if (!file[0] ||			/* null path */
	file[0] == '/' ||		/* absolute path */
	strcmp(file, "-") == 0 ||	/* stdin/stdout */
	!dir[0])			/* we don't HAVE_GETCWD */
	return xstrdup (file);
    newfile = (char *)xmalloc (strlen (dir) + 1 + strlen (file) + 1);
    if (dir[strlen(dir) - 1] != '/')
	sprintf (newfile, "%s/%s", dir, file);
    else
	sprintf (newfile, "%s%s", dir, file);
    return newfile;
}

/* rcfile_y.y ends here */
